function Merge()
	local player = Turbine.Gameplay.LocalPlayer.GetInstance()
	local backpack = player:GetBackpack()
	local size = backpack:GetSize()

	Timer = Turbine.UI.Control()

	function Timer:Start()
		write( "HugeBag: Merging started" );
		Timer:SetWantsUpdates( true );
	end
	
	function Timer:Update()
		for DestSlot = 1, size do
			TargetItem = backpack:GetItem(DestSlot);
			TargetName = "zEmpty"
			--Get the name of the destination item
			if TargetItem ~= nil then TargetName = TargetItem:GetName(); end
			
			for SourceSlot = DestSlot + 1, size do
				SourceItem = backpack:GetItem(SourceSlot);
				SourceName = "zEmpty"
				--Get the name of the source item
				if SourceItem ~= nil then SourceName = SourceItem:GetName(); end
				
				if SourceName == TargetName then
					swop( DestSlot, SourceSlot );
				end
			end
		end

		Timer:SetWantsUpdates( false )
		Timer = nil
		backpack = nil
		SortButton:SetVisible( true );
		SearchButton:SetVisible( true );
		MergeButton:SetVisible( true );
		write( "HugeBag: Merging finished" );
	end

	function swop(i,j)
	
		if backpack:GetItem(j)==backpack:GetItem(i) then return end
		
		item = backpack:GetItem(j)

		if item ~= nil then
			backpack:PerformItemDrop(item,i, false)
			return
		end
		
		write("Should never be seen. Error in Swop function.")
	end

	Timer:Start()
end