-- functionsWidget.lua
-- Written By Habna


-- **v Toggle Startup Visibility v**
function ToggleShow()
	StartVisible = ( not StartVisible );
	SaveSettings()
	if ( StartVisible ) then
		write( "HugeBag: I will load visibile next time" );
	else
		write( "HugeBag: I will load hidden next time" );
	end
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	HideWEsc = ( not HideWEsc );
	SaveSettings()
	if ( HideWEsc ) then
		write( "HugeBag: I will hide when 'esc' key is press" );
	else
		write( "HugeBag: I will stay visible when 'esc' key is press" );
	end
end
-- **^
-- **v Toggle to use widget mode are not v**
function ToggleWidgetMode()
	Widget = ( not Widget );
	SaveSettings()
	if ( Widget ) then
		write( "HugeBag: Will load in widget mode next time" );
	else
		write( "HugeBag: Will load in window mode next time" );
	end
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.ShellCmdWidget"; -- LUA frmShellCmd file
	frmShellCmdWidget()
end
-- **^
-- **v Change Widget Location to right v**
function WidLocRight()
	WidgetLoc = "right";
	WidLoc()
end
-- **^
-- **v Change Widget Location to left v**
function WidLocLeft()
	WidgetLoc = "left";
	WidLoc()
end
-- **^
-- **v Save Widget Location v**
function WidLoc()
	SaveSettings()
	
	if WidgetLoc == "right" then
		if windowOpen then
			frmMain:SetLeft( screenWidth - ( winRate * 15 ) );
		else
			frmMain:SetLeft( screenWidth - 30 );
		end
	elseif WidgetLoc == "left" then
		if windowOpen then
			frmMain:SetLeft( 1 );
		else
			frmMain:SetLeft( -419 );
		end
	end
end
-- **^
-- **v Show About window v**
function ShowAbout()
	import "HabnaPlugins.HugeBag.About"; -- LUA frmAbout file
	frmAbout();
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.backgroundWidget"; -- LUA frmOptions file
	frmBackground();
end
-- **^
-- **v Show Help Info v**
function ReloadHugeBag()
	--UnloadHugeBag()
	--LoadHugeBag()
end
-- **^
-- **v Show Help Info v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( "HugeBag" );
end
-- **^
-- **v Show HugeBag v**
function ShowHugeBag()
	if ( windowOpen ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		slideCtr:SetWantsUpdates(true);
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not windowOpen ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		slideCtr:SetWantsUpdates(true);
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Move button to left v**
function MoveButtonLeft()
	MoveTo = "left";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButtonRight()
	MoveTo = "right";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButton()
	--write( "moving " .. FromButton .. " to " .. MoveTo );
	if ( MoveTo == "left" ) then
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == LeftPos then
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		end
	else
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == RightPos then
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		end
	end
	SortButton:SetLeft( SortLeft );
	SearchButton:SetLeft( SearchLeft );
	MergeButton:SetLeft( MergeLeft );
	SaveSettings();
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show"
	ShellCommandName[2]= "hide"
	ShellCommandName[3]= "unload"
	ShellCommandName[4]= "reload"
	ShellCommandName[5]= "resetall"
	ShellCommandName[6]= "togglewesc"
	ShellCommandName[7]= "toggleshow"
	ShellCommandName[8]= "togglewidget"
	ShellCommandName[9]= "sort"
	ShellCommandName[10]= "merge"
	ShellCommandName[11]= "about"
	ShellCommandName[12]= "help/?"
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag"
	ShellCommandDes[2]= "Hide HugeBag"
	ShellCommandDes[3]= "Unload HugeBag (NOT WORKING, Turbine API Issues)"
	ShellCommandDes[4]= "Reload HugeBag (NOT WORKING, Turbine API Issues)"
	ShellCommandDes[5]= "Reset all settings to default"
	ShellCommandDes[6]= "Toggle hide HugeBag event when the 'esc' key is press"
	ShellCommandDes[7]= "Show or hide HugeBag at startup"
	ShellCommandDes[8]= "Toggle between widget and window mode"
	ShellCommandDes[9]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[10]= "Merge HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[11]= "Show the 'About' window"
	ShellCommandDes[12]= "Show HugeBag shell commands/?"
end

-- Create ten hacky resize cursors
function createCursor( cursorName, xOffset, yOffset, xSize, ySize )
	cursor = Turbine.UI.Window();
	cursor:SetSize( xSize, ySize );
	cursor:SetBackground( "HabnaPlugins/HugeBag/Resources/"..cursorName..".tga" );
	cursor:SetMouseVisible( false );
	cursor:SetZOrder( 10 );
	
	cursor.xOffset = xOffset;
	cursor.yOffset = yOffset;
	
	return cursor;
end

updownCursor = createCursor( "arrow_updown", 12, 12, 24, 24 );
up_down_right_clic = createCursor( "up_down_right_clic", 12, 12, 39, 24 );

function mergetable(table1,list)
	--Appends tables from list on the end of table1
	for i=1,#list do
		table2=list[i]
		local LenTable1=#table1
		for a =LenTable1+1,#table1+#table2 do
			table1[a]=table2[a-LenTable1]
		end
	end
end

function Search()
	local searchString = "";
	
	if SearchInput then
		searchString = string.upper( SearchInput:GetText() );
	end
	
	for i = 1, backpackSize, 1 do
		itemsCtl = itemListBox:GetItem( i );
		tmpBackPackItem = frmMain.backpack:GetItem( itemsCtl.itemIndex );
		if itemsCtl and tmpBackPackItem then
			if string.find( string.upper( tmpBackPackItem:GetName() ), searchString ) or ( searchString == "" ) then
				items[i]:SetVisible( true );
			else
				items[i]:SetVisible( false );
			end
		end
	end
end